"
COPYRIGHT (c) 2020 LabWare
"
"{ Package: 'stx:goodies/monticello/test' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#stx_goodies_monticello_test
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_monticello_test class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare

"
! !

!stx_goodies_monticello_test class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes.
     Please take a look at the #referencedPreRequisites method as well."

    ^ #(
        #'stx:goodies/monticello'    "MCMock - superclass of MCMockASubclass"
        #'stx:goodies/sunit'    "TestAsserter - superclass of MCAncestryTest"
        #'stx:libbasic'    "LibraryDefinition - superclass of stx_goodies_monticello_test"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     These packages are NOT needed as a prerequisite for compiling or loading,
     however, a class from it may be referenced during execution and having it
     unloaded then may lead to a runtime doesNotUnderstand error, unless the caller
     includes explicit checks for the package being present.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes.
     Please also take a look at the #mandatoryPreRequisites method"

    ^ #(
        #'stx:libbasic2'    "UUID - referenced by MCTestCase>>mockVersionInfo:"
        #'stx:libcomp'    "Parser - referenced by MCStWriterTest>>assertChunkIsWellFormed:"
        #'stx:libcompat'    "FileDirectory - referenced by MCMczInstallerTest>>deleteFile"
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!stx_goodies_monticello_test class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        MCDependencySorterTest
        MCMockClassA
        MCMockClassB
        MCMockClassD
        MCMockClassE
        MCMockClassF
        MCMockClassG
        MCMockClassH
        MCMockClassI
        MCSnapshotResource
        MCSortingTest
        MCTestCase
        #'stx_goodies_monticello_test'
        MCAncestryTest
        MCChangeNotificationTest
        MCClassDefinitionTest
        MCFileInTest
        MCInitializationTest
        MCMczInstallerTest
        MCMergingTest
        MCMethodDefinitionTest
        MCMockASubclass
        MCOrganizationTest
        MCPackageTest
        MCPatchTest
        MCRepositoryTest
        MCScannerTest
        MCSerializationTest
        MCSnapshotBrowserTest
        MCSnapshotTest
        MCStReaderTest
        MCStWriterTest
        MCVersionTest
        MCWorkingCopyTest
        MCDictionaryRepositoryTest
        MCDirectoryRepositoryTest
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector.
     A correponding method with real names must be present in my concrete subclasses
     if it has extensions."

    ^ #(
    )
! !

!stx_goodies_monticello_test class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2010\nCopyright eXept Software AG 1998-2010'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_monticello_test class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/test/stx_goodies_monticello_test.st,v 1.3 2013-05-29 00:04:51 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/test/stx_goodies_monticello_test.st,v 1.3 2013-05-29 00:04:51 vrany Exp $'
!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

