"
COPYRIGHT (c) 2020-2021 LabWare
"
"{ Package: 'stx:goodies/monticello/tonel' }"

"{ NameSpace: Smalltalk }"

Object subclass:#TonelFileUtils
	instanceVariableNames:''
	classVariableNames:'Current'
	poolDictionaries:''
	category:'SCM-Monticello-Tonel-Core'
!

!TonelFileUtils class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020-2021 LabWare


"
! !

!TonelFileUtils class methodsFor:'initialization'!

initialize
    ((Smalltalk respondsTo: #isSmalltalkX) and:[ Smalltalk isSmalltalkX ]) ifTrue:[
        TonelFileUtilsStX install.
    ] ifFalse: [
        self error: 'No TonelFileUtils implementation for this dialect'.
    ].

    "Created: / 04-06-2019 / 11:42:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2021 / 10:53:46 / Jan Vrany <jan.vrany@labware.com>"
!

install
    Current := self
! !

!TonelFileUtils class methodsFor:'accessing'!

current
    ^ Current
! !

!TonelFileUtils class methodsFor:'utilities'!

buildPathFrom: pathCollection
    ^ String
        streamContents: [ :stream | pathCollection do: [ :element | stream nextPutAll: element ] separatedBy: [ stream nextPut: self pathNameDelimiter ] ]
!

default
    self subclassResponsibility
!

deleteAll: aDirectory
    aDirectory recursiveRemove

    "Modified: / 04-06-2019 / 11:44:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

directoryExists: aDirectory
    ^ aDirectory isDirectory

    "Modified: / 04-06-2019 / 11:44:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

directoryFromPath: directoryPath
    self subclassResponsibility
!

directoryFromPath: directoryPath relativeTo: aDirectory
    ^ self subclassResponsibility

    "Modified: / 04-06-2019 / 12:06:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2021 / 10:49:36 / Jan Vrany <jan.vrany@labware.com>"
!

directoryName: aDirectory
    self subclassResponsibility
!

directoryPathString: aDirectory
    self subclassResponsibility
!

ensureDirectoryExists: aDirectory
    aDirectory makeDirectory

    "Modified: / 04-06-2019 / 11:44:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ensureFilePathExists: fileNameOrPath relativeTo: aDirectory
    self subclassResponsibility
!

fileName: aDirectory
    self subclassResponsibility
!

filePathExists: filePath relativeTo: aDirectory
    self subclassResponsibility
!

parentDirectoryOf: aDirectory
    self subclassResponsibility
!

pathNameDelimiter
    self subclassResponsibility
!

readStreamFor: filePath do: aBlock
    self subclassResponsibility
!

readStreamFor: filePath in: aDirectory do: aBlock
    self subclassResponsibility
!

resolvePath: path in: aDirectory
    self subclassResponsibility
!

writeStreamFor: filePath in: aDirectory do: aBlock
    self subclassResponsibility

    "Modified: / 04-06-2019 / 11:46:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-02-2021 / 09:47:03 / Jan Vrany <jan.vrany@labware.com>"
! !

!TonelFileUtils class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !


TonelFileUtils initialize!
